package coursework;

import javafx.animation.Timeline;
import java.util.ArrayList;
import java.util.List;
import javafx.animation.KeyFrame;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.layout.VBox;
import javafx.util.Duration;

public class Animation {

	private int N;
	private VBox[] gridBoxes;
	private String[] colors = {"#FF0000", "#FF7F00", "#FFFF00", "#00FF00", "#00FFFF", "#0000FF", "#462370", "#7F00FF", "rgba(255,0,0,0)"};
	private Integer[] indexArray;
	private List<Integer> indexList = new ArrayList<Integer>();
	private int index = 0;
	private int count = 1;
	private int colorIndex = 0;

	public Animation() {
		gridBoxes = Main.getGridBoxes();
		N = Main.getN();
	}
	
	public void go() {
		initialiseIndex();
		Timeline timeline = new Timeline();
		KeyFrame keyframe = new KeyFrame(Duration.seconds(0.1), e -> {
			if (index != indexArray.length) {
				for (int j = 0; j < colors.length; j++) {
					if (index - j >= 0) {
						if (indexArray[index - j] >= 0 && indexArray[index] - j <= N*N) {
							gridBoxes[indexArray[index - j]].setStyle("-fx-background-color:"+colors[j]+";");
						}
					}
				}
				index++;
			}
			if (index == indexArray.length && count < 9) {
				for (int i = 0; i < colors.length - count; i++) {
					gridBoxes[indexArray[indexArray.length - i - 1]].setStyle("-fx-background-color:"+colors[i+count]+";");
				}
				count++;
			}
			if (count == 9) {
				if (N % 2 == 0  && colorIndex % 2 == 0 && colorIndex < 23 ) {
					//even
					int maxCentre = N / 2;
					int minCentre = maxCentre - 1;
					
					int topLeft = (minCentre * N) + minCentre;
					int topRight = (minCentre * N) + maxCentre;
					int botLeft = (maxCentre * N) + minCentre;
					int botRight = (maxCentre * N + maxCentre);
					int[] gridIndicies = { topLeft, topRight, botLeft, botRight };
					
					if (colorIndex/2 < colors.length) {
						for (int gridIndex : gridIndicies) {
							gridBoxes[gridIndex].setStyle("-fx-background-color:"+colors[colorIndex/2]+";");
						}
					}
					if (colorIndex/2 - 1 > 0 && colorIndex/2 < colors.length + 1 && N > 2) {						
						int[] ringCombinations1 = {1, N + 1, N};
						for (int ringVal : ringCombinations1) {
							gridBoxes[botRight + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 1]+";");
							gridBoxes[topLeft - ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 1]+";");
						}
						int[] ringCombinations2 = {- 1, N - 1, N};
						for (int ringVal : ringCombinations2) {
							gridBoxes[botLeft + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 1]+";");
							gridBoxes[topRight - ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 1]+";");
						}
					}
					if (colorIndex/2 - 2 > 0 && colorIndex/2 < colors.length + 2 && N > 4) {
						int[] ringCombinations1 = {2, N + 2, 2*N + 2, 2*N + 1, 2*N};
						for (int ringVal : ringCombinations1) {
							gridBoxes[botRight + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 2]+";");
							gridBoxes[topLeft - ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 2]+";");
						}
						int[] ringCombinations2 = {- 2, N - 2, 2*N - 2, 2*N - 1, 2*N};
						for (int ringVal : ringCombinations2) {
							gridBoxes[botLeft + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 2]+";");
							gridBoxes[topRight - ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 2]+";");
						}
					}
					if (colorIndex/2 - 3 > 0 && colorIndex/2 < colors.length + 3 && N > 6) {
						int[] ringCombinations1 = {3, N + 3, 2*N + 3, 3*N + 3, 3*N + 2, 3*N + 1, 3*N};
						for (int ringVal : ringCombinations1) {
							gridBoxes[botRight + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 3]+";");
							gridBoxes[topLeft - ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 3]+";");
						}
						int[] ringCombinations2 = {- 3, N - 3, 2*N - 3, 3*N - 3, 3*N - 2, 3*N - 1, 3*N};
						for (int ringVal : ringCombinations2) {
							gridBoxes[botLeft + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 3]+";");
							gridBoxes[topRight - ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 3]+";");
						}
					}
					colorIndex++;
				}
				else if (colorIndex % 2 == 0) {
					//odd 
					int centrePoint = (N - 1) / 2;
					int centre = (centrePoint * N) + centrePoint;
					
					if (colorIndex/2 < colors.length) {
						gridBoxes[centre].setStyle("-fx-background-color:"+colors[colorIndex/2]+";");
					}
					
					if (colorIndex/2 - 1 > 0 && colorIndex/2 < colors.length + 1) {
						int[] firstRing = {- 1 - N, - N, 1 - N, - 1, + 1, - 1 + N, N, 1 + N };
						for (int ringVal : firstRing) {
							gridBoxes[centre + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 1]+";");
						}
					}
					if (colorIndex/2 - 2 > 0 && colorIndex/2 < colors.length + 2 && N > 3) {
						int[] secondRing = { -2*N - 2, - 2*N - 1, - 2*N, - 2*N + 1, - 2*N + 2, - N - 2, - N + 2, 2, -2, N - 2, N + 2,
								2*N - 2, 2*N - 1, 2*N, 2*N + 1, 2*N + 2 };
						for (int ringVal : secondRing) {
							gridBoxes[centre + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 2]+";");
						}
					}
					if (colorIndex/2 - 3 > 0 && colorIndex/2 < colors.length + 3 && N > 5) {
						int[] thirdRing = { -3*N - 3, - 3*N - 2, -3*N - 1, - 3*N, - 3*N + 1, - 3*N + 2, - 3*N + 3, - N - 3, - N + 3, 3, -3, N - 3,
								N + 3, 2*N - 3, 2*N + 3, -2*N + 3, -2*N - 3, 3*N - 3, 3*N - 2, 3*N - 1, 3*N, 3*N + 1, 3*N + 2, 3*N + 3};
						for (int ringVal : thirdRing) {
							gridBoxes[centre + ringVal].setStyle("-fx-background-color:"+colors[colorIndex/2 - 3]+";");
						}
					}
					colorIndex++;
				}
				else {
					colorIndex++;
				}
			}
			if (colorIndex == 23) {
				Alert alert = new Alert(AlertType.INFORMATION);
				alert.setContentText("Congratulations! You have completed this Mathdoku puzzel.");
				alert.setTitle("Puzzel Complete");
				alert.show();
			}
			
		});
		timeline.getKeyFrames().add(keyframe);
		timeline.setCycleCount(indexArray.length + 30);
		timeline.play();
	}
		
	private void initialiseIndex() {
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (i % 2 == 0) {
					indexList.add(i*N + j);
				}
				else {
					indexList.add((i+1) * N - 1 - j);
				}
			}
		}
		
		if (getPrevious(indexList) % N == 0) {
			// even n
			for (int j = 0; j < N / 2; j++) {
				moveUpDown(1, N - 1);
				moveLeftRight(1, 1);
				moveUpDown(-1, N - 1);
				if (j != N/2 - 1) {
					moveLeftRight(1, 1);
				}
			}
			
			int count = N - 1;
			moveLeftRight(-1, count);
			moveUpDown(1, count);
			moveLeftRight(1, count);
			count--;
			
			while (count > 0) {
				moveUpDown(-1, count);
				moveLeftRight(-1, count);
				count--;
				moveUpDown(1, count );
				moveLeftRight(1, count);
				count--;
			}
		}
		else {
			// odd n
			for (int j = 0; j < N / 2; j++) {
				moveUpDown(1, N - 1);
				moveLeftRight(-1, 1);
				moveUpDown(-1, N - 1);
				moveLeftRight(-1, 1);
			}
			moveUpDown(1, N - 1);
			
			int count = N - 1;
			moveLeftRight(1, count);
			moveUpDown(-1, count);
			moveLeftRight(-1, count);
			
			while (count > 3) {
				count--;
				moveUpDown(1, count);
				moveLeftRight(1, count);
				count--;
				moveUpDown(-1, count);
				moveLeftRight(-1, count);
			}
			count--;
			moveUpDown(1, count);
			moveLeftRight(1, count);
		}		
		
		indexArray = indexList.toArray(new Integer[indexList.size()]);
	}
	
	private Integer getPrevious(List<Integer> indexList) {
		return indexList.get(indexList.size() - 1);
	}
	
	private void moveUpDown(int value, int n) {
		// value == 1 to move up, value == -1 to move down
		for (int i  = 0; i < n; i++) {
			indexList.add(getPrevious(indexList) - N*value);
		}
	}
	
	private void moveLeftRight(int value, int n) {
		// value == 1, move right, value == -1 move left
		for (int i  = 0; i < n; i++) {
			indexList.add(getPrevious(indexList) + value);
		}
	}
}
