package coursework;

import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.shape.Line;
import javafx.scene.shape.Rectangle;

public class Square {
	
	private double size;
	private Rectangle rectangle;
	private Line top;
	private Line right;
	private Line bottom;
	private Line left;
	private Group group = new Group();
	
	public Square(double size) {
		this.size = size;
		draw();
	}
	
	public void draw() {
		rectangle = new Rectangle(0, 0, size, size);
		rectangle.setFill(Color.WHITE);
		rectangle.setStrokeWidth(0);
		top = new Line(0, 0, size, 0);
		right = new Line(size, 0, size, size);
		bottom = new Line(size, size, 0, size);
		left = new Line(0, size, 0, 0);
		group.getChildren().addAll(rectangle, top, right, bottom, left);
	}
	
	public Group getGroup() {
		return group;
	}
	
	public Rectangle getRectangle() {
		return rectangle;
	}
	
	public void resizeLines(double newSize) {
		top.setEndX(newSize );
		
		right.setStartX(newSize);
		right.setEndX(newSize);
		right.setEndY(newSize);

		bottom.setStartX(newSize);
		bottom.setStartY(newSize);
		bottom.setEndY(newSize);

		left.setStartY(newSize);
	}
	
	public void setTopStroke(double width, Color color) {
		top.setStrokeWidth(width);
		top.setStroke(color);
	}
	
	public void setRightStroke(double width, Color color) {
		right.setStrokeWidth(width);
		right.setStroke(color);
	}
	
	public void setBottomStroke(double width, Color color) {
		bottom.setStrokeWidth(width);
		bottom.setStroke(color);
	}
	
	public void setLeftStroke(double width, Color color) {
		left.setStrokeWidth(width);
		left.setStroke(color);
	}
}